"""Graph utilities to generate path candidates, as used by exhaustive Ray Tracing methods, e.g., the Image Method."""

__all__ = (
    "CompleteGraph",
    "DiGraph",
    "AllPathsFromCompleteGraphIter",
    "AllPathsFromCompleteGraphChunksIter",
    "AllPathsFromDiGraphIter",
    "AllPathsFromDiGraphChunksIter",
)

from .. import _lowlevel

AllPathsFromCompleteGraphChunksIter = (
    _lowlevel.rt.graph.AllPathsFromCompleteGraphChunksIter
)
AllPathsFromCompleteGraphIter = _lowlevel.rt.graph.AllPathsFromCompleteGraphIter
AllPathsFromDiGraphChunksIter = _lowlevel.rt.graph.AllPathsFromDiGraphChunksIter
AllPathsFromDiGraphIter = _lowlevel.rt.graph.AllPathsFromDiGraphIter
CompleteGraph = _lowlevel.rt.graph.CompleteGraph
DiGraph = _lowlevel.rt.graph.DiGraph
